﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace pr182_1
{
    delegate double Powers(double x); 

    class Program
    {
        static Powers maker(int n) {
            Powers meth;
            // Значением переменной типа делегата присваивается 
            // лямбда-выражение: 
            meth = x => { 
                double s=1;
                for(int i = 1;i <= n; i++) { 
                    s *= x;
                }
                return s;
            };
            return meth;
        }

        static void Main()
        {
            Powers sqr = maker(2);
            Powers cube = maker(3); 
            for(int i = 1; i <= 5; i++) {
                Console.WriteLine("{0,2}:{1,5}{2,5}{3,5}", i, 
                    sqr(i), cube(i), maker(4)(i));
            }
            // Задержка:
            Console.ReadLine();
        }
    }
}
